「日常训练」Skills(Codeforce Round Div.2 #339 D)

题意(CodeForces 614D)

每个人有\(n(n\le 10^5)\)个技能,技能等级都在\([0,10^9]\)的范围,每个技能有一个当前等级,所有技能的最高等级都为A。一个人的力量被记做以下两项的和:

1. 顶级技能的个数 *cf

2. 最低等级的技能 *cm

每个单位的钱能够提升一级力量。我们希望花尽可能少的钱,使得力量尽可能高。

分析

我二分的功力还是不足,要多努力。这题其实是一个非常明显的暴力:我们枚举提高到A的等级的个数(到不能提升为止),枚举这种情况下,我们能够令把多少人的等级提升到相同的某个等级——这个地方可以用二分解决(先排序)。这样遍历一遍整个等级,就能得到最优的策略,然后输出答案即可。具体的代码细节见注释。

代码

/*
 * Filename: cfr339d2d.cpp
 * Date: 2018-11-07
 */

#include <bits/stdc++.h>

#define INF 0x3f3f3f3f
#define PB emplace_back
#define MP make_pair
#define fi first
#define se second
#define rep(i,a,b) for(repType i=(a); i<=(b); ++i)
#define per(i,a,b) for(repType i=(a); i>=(b); --i)
#define ZERO(x) memset(x, 0, sizeof(x))
#define MS(x,y) memset(x, y, sizeof(x))
#define ALL(x) (x).begin(), (x).end()

#define QUICKIO                      ios::sync_with_stdio(false);     cin.tie(0);                      cout.tie(0);
#define DEBUG(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;
using pi=pair<int,int>;
using repType=int;
using ll=long long;
using ld=long double;
using ull=unsigned long long;

const int MAXN=100005;

struct Skill
{
    int v,o;
    Skill() {}
    Skill(int _v, int _o):v(_v), o(_o) {}
} a[MAXN];

int n;
ll A,cf,cm,m,sum[MAXN];

int solve(int R, ll now) // given present cost, and r which tells 1~r are not A,
{                        // which lowest lv can you reach?
    if(R==0) return A;
    int l=1, r=R;
    while(l<r)
    {
        int mid=(l+r+1)/2;
        ll need=ll(a[mid].v)*mid-sum[mid];  // we need it to make pre n people
        if (need>now) r=mid-1; else l=mid; // reach the lv of the nth.
    }
    ll need=ll(a[l].v)*l-sum[l];
    ll more=(now-need)/l;
    return min(ll(A), a[l].v+more);
}

int
main()
{
    scanf("%d%lld%lld%lld%lld", &n, &A, &cf, &cm, &m);
    rep(i,1,n)
    {
        scanf("%d", &a[i].v);
        a[i].o=i;
    }
    sort(a+1, a+n+1, [](Skill& x, Skill& y) -> bool
                     {
                         return x.v<y.v;
                     });
    a[n+1].v=A;

    rep(i,1,n) sum[i]=sum[i-1]+a[i].v;

    ll ans=-1, cost=0;
    int v,p;
    per(i,n,0)
    {
        cost+=A-a[i+1].v; if(cost>m) break;
        int minv=solve(i,m-cost);
        ll tmp=minv*cm+(n-i)*cf;
        if(tmp>ans)
        {
            ans=tmp;
            p=i;
            v=minv;
        }
    }

    printf("%lld\n", ans);
    per(i,n,p+1) a[i].v=A;
    rep(i,1,p) a[i].v=max(a[i].v, v);
    sort(a+1, a+n+1, [](Skill& x, Skill& y) -> bool
                     {
                         return x.o<y.o;
                     });
    rep(i,1,n)
        printf("%d ", a[i].v);
    printf("\n");

    return 0;
}

原文地址:https://www.cnblogs.com/samhx/p/CFR339D2D.html

时间: 2024-10-14 01:22:17

「日常训练」Skills(Codeforce Round Div.2 #339 D)的相关文章

「日常训练」Bad Luck Island(Codeforces Round 301 Div.2 D)

题意与分析(CodeForces 540D) 代码 #include <iomanip> #include <iostream> #include <cstring> #include <algorithm> #include <vector> #define MP make_pair #define PB push_back #define fi first #define se second #define ZERO(x) memset((x

「日常训练」School Marks(Codeforces Round 301 Div.2 B)

题意与分析(CodeForces 540B) 代码 #include <iostream> #include <cstring> #include <algorithm> #include <vector> #define MP make_pair #define PB push_back #define fi first #define se second #define ZERO(x) memset((x), 0, sizeof(x)) #define

「日常训练」Ice Cave(Codeforces Round 301 Div.2 C)

题意与分析(CodeForces 540C) 这题坑惨了我....我和一道经典的bfs题混淆了,这题比那题简单. 那题大概是这样的,一个冰塔,第一次踩某块会碎,第二次踩碎的会掉落.然后求可行解. 但是这题...是冰塔的一层 也就是说,它只是个稍微有点限制的二维迷宫问题. 后面就好理解了,不过需要考虑下这种数据: 1 2 XX 1 1 1 1 这种数据答案是no.解决的方法可以考虑这样:分成两个数组来记录访问状态:vis数组和block数组. 代码 #include <queue> #inclu

「日常训练」Paths and Trees(Codeforces Round 301 Div.2 E)

题意与分析 代码 #include <bits/stdc++.h> #define MP make_pair #define PB emplace_back #define fi first #define se second #define ZERO(x) memset((x), 0, sizeof(x)) #define ALL(x) (x).begin(),(x).end() #define rep(i, a, b) for (repType i = (a); i <= (b);

「日常训练」Woodcutters(Codeforces Round 303 Div.2 C)

这题惨遭被卡..卡了一个小时,太真实了. 题意与分析 (Codeforces 545C) 题意:给定\(n\)棵树,在\(x\)位置,高为\(h\),然后可以左倒右倒,然后倒下去会占据\([x-h,x]\)或者\([x,x+h]\)区间,如果不砍伐,占据\([x,x]\)区域. 问你最多砍多少棵树,砍树的条件是倒下去后占有的区间不能被其他树占据. 分析:在这条题目的条件下,这是一个傻逼贪心题.(然后我读错两次题目,怎么也想不出来贪心策略....) 很简单的策略:能往左倒往左倒,能往右倒往右倒.因

「日常训练」Regular Bridge(Codeforces Round 306 Div.2 D)

题意与分析 图论基础+思维题. 代码 #include <bits/stdc++.h> #define MP make_pair #define PB emplace_back #define fi first #define se second #define ZERO(x) memset((x), 0, sizeof(x)) #define ALL(x) (x).begin(),(x).end() #define rep(i, a, b) for (repType i = (a); i &

「日常训练」Brackets in Implications(Codeforces Round 306 Div.2 E)

题意与分析 稍微复杂一些的思维题.反正这场全是思维题,就一道暴力水题(B). 代码 #include <bits/stdc++.h> #define MP make_pair #define PB emplace_back #define fi first #define se second #define ZERO(x) memset((x), 0, sizeof(x)) #define ALL(x) (x).begin(),(x).end() #define rep(i, a, b) fo

「日常训练」All Friends(POJ-2989)

题意 分析 代码 #include <iostream> #include <cstring> #include <algorithm> #define MP make_pair #define PB emplace_back #define fi first #define se second #define ZERO(x) memset((x), 0, sizeof(x)) #define ALL(x) (x).begin(),(x).end() #define r

「日常训练」Battle Over Cities - Hard Version(PAT-TOP-1001)

题意与分析 题意真的很简单,实在不想讲了,简单说下做法吧. 枚举删除每个点,然后求最小生成树,如果这个路已经存在那么边权就是0,否则按照原来的处理,之后求花费,然后判整个图是否联通(并查集有几个root),如果不联通直接硬点花费是INF,然后处理输出答案即可. 一道最小生成树的模板题,比较有学习的意义. 代码 /* * Filename: pat_top_1001.cpp * Date: 2018-11-05 */ #include <bits/stdc++.h> #define INF 0x